import { type ZodLazy } from 'zod';
import { type FieldSchema, type QuerySchema } from './query-schema.js';
import type { GraphqlValue } from './values/value.js';
import { type VariableDefinitions } from './variable-definition.js';
type GraphqlFieldOptions = {
    aliasFor?: string;
    parameters?: Record<string, GraphqlValue>;
};
export type OperationOptions = {
    operationName?: string | undefined;
    variableDefinitions?: VariableDefinitions | undefined;
};
export type QueryBuilder = {
    registerFieldOptions: <Schema extends FieldSchema>(schema: Schema, options: GraphqlFieldOptions) => ZodLazy<Schema>;
    buildQuery: <Schema extends QuerySchema>(schema: Schema, options?: OperationOptions) => string;
    buildMutation: <Schema extends QuerySchema>(schema: Schema, options?: OperationOptions) => string;
};
export declare function createQueryBuilder(): QueryBuilder;
export {};
//# sourceMappingURL=builder.d.ts.map